import sys, os, locale

from math import *
import numpy, tables, scipy
import Rappture

import xml.etree.ElementTree as ET

import warnings
warnings.simplefilter('ignore',UserWarning)

class Atom:
  def __init__(self,io,toolDir):
    self.here = 'input.phase(two).group(atom).group(input).'
    self.xml = ET.parse("%s/templates/%s" % (toolDir,"atom.xml"))

    # Handle the atomic number.
    names = ["H","He","Li","Be","B","C"] 
    atomicMass = [1.007825,4.002603,7.016004,9.012182,11.009305,12]
    atomicZ = locale.atoi(io.get(self.here+'choice(Z).current'))
    name = names[atomicZ-1]
    node = self.xml.find(".//Species")
    node.set("charge", "%i"%atomicZ)
    node.set("name", name)
    node.set("mass", "%f amu"%atomicMass[atomicZ-1])
    for node in self.xml.findall(".//*[@species='H']"):
      node.set('species', name)
    for node in self.xml.findall(".//*[@species1='H']"):
      node.set('species1', name)
    for node in self.xml.findall(".//*[@species2='H']"):
      node.set('species2', name)
      
    # Remove unwanted estimators.
    estNode = self.xml.find(".//Estimators")
    if io.get(self.here+'group(est).boolean(energy).current')=="no":
      rmNode = self.xml.find(".//ThermalEnergyEstimator")
      estNode.remove(rmNode)
      rmNode = self.xml.find(".//VirialEnergyEstimator")
      estNode.remove(rmNode)
    if io.get(self.here+'group(est).boolean(potEnergy).current')=="no":
      rmNode = self.xml.find(".//CoulombEnergyEstimator")
      estNode.remove(rmNode)

  def writeXML(self):
    self.xml.write("pimc.xml",xml_declaration=True,encoding='us-ascii')
