import sys, os, tempfile, zipfile, tarfile
from math import *
import numpy, tables, scipy
import Rappture

import xml.etree.ElementTree as ET

import warnings
warnings.simplefilter('ignore',UserWarning)

class Expert:
  def __init__(self,io,toolDir):
    self.io = io
    self.here = 'input.phase(two).group(expert).'
    # Read optional input files.
    format = self.io.get(self.here+'choice(upload).current')
    if (format == "paths"):
      data = self.io.get(self.here+'string(upload).current')
      file = open("paths.in","w")
      file.write(data)
      file.close()
    if (format == "targz"):
      data = self.io.get(self.here+'string(upload).current')
      file = tempfile.NamedTemporaryFile()
      #file = open("upload.tar.gz","w+b")
      file.write(data)
      file.flush()
      #Extract tarfile contents. 
      tgzfile = tarfile.open(file.name)
      for name in tgzfile.getnames():
        if name.endswith('/'):
          os.mkdir(name)
        else:
          outfile = open(name,'wb')
          outfile.write(tgzfile.extractfile(name).read())
          outfile.close()
      #Delete the temporary tarfile.
      file.close()
    if (format == "zip"):
      #Grab the zipfile from self.io.
      data = self.io.get(self.here+'string(upload).current')
      file = tempfile.TemporaryFile()
      file.write(data)
      file.flush()
      #Extract zipfile contents. 
      zfile = zipfile.ZipFile(file)
      for name in zfile.namelist():
        if name.endswith('/'):
          os.mkdir(name)
        else:
          outfile = open(name,'wb')
          outfile.write(zfile.read(name))
          outfile.close()
      #Delete the temporary zipfile.
      file.close()


  def writeXML(self):
    pimcXML = self.io.get(self.here+'group(indeck).string(indeck).current')
    infile = open("pimc.xml","w")
    infile.write(pimcXML)
    infile.close()
