// $Id: SimInfoWriter.cc,v 1.2 2007/07/02 02:49:55 jshumwa Exp $
/*  Copyright (C) 2004-2006 John B. Shumway, Jr.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "SimInfoWriter.h"
#include "SimulationInfo.h"
#include "SuperCell.h"
#include <string>
#include <iostream>
#include <vector>

SimInfoWriter::SimInfoWriter(const SimulationInfo &simInfo)
  : simInfo(simInfo) {
}

void SimInfoWriter::writeH5(H5::H5File &file) const {
  std::cout << "Writing simulation info to pimc.h5." << std::endl;
  H5::Group group=file.createGroup("simInfo");
  hsize_t dims[] = {1};
  group.createDataSet("temperature",H5::PredType::NATIVE_DOUBLE,
                        H5::DataSpace(1,dims))
       .write(&simInfo.temperature, H5::PredType::NATIVE_DOUBLE);
  group.createDataSet("deltaTau",H5::PredType::NATIVE_DOUBLE,
                        H5::DataSpace(1,dims))
       .write(&simInfo.tau, H5::PredType::NATIVE_DOUBLE);
  group.createDataSet("nslice",H5::PredType::NATIVE_INT,
                        H5::DataSpace(1,dims))
       .write(&simInfo.nslice, H5::PredType::NATIVE_INT);
  group.createDataSet("npart",H5::PredType::NATIVE_INT,
                        H5::DataSpace(1,dims))
       .write(&simInfo.npart, H5::PredType::NATIVE_INT);
  dims[0]=NDIM;
  group.createDataSet("superCell",H5::PredType::NATIVE_DOUBLE,
                        H5::DataSpace(1,dims))
       .write(&simInfo.superCell->a, H5::PredType::NATIVE_DOUBLE);

}
